/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.estate.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.community.entity.Floor;
import org.springblade.community.feign.IFloorClient;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.BladeUser;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.estate.dto.BillsDTO;
import org.springblade.estate.entity.Bills;
import org.springblade.estate.entity.BillsItem;
import org.springblade.estate.service.IBillsItemService;
import org.springblade.estate.service.IBillsService;
import org.springblade.estate.vo.BillsVO;
import org.springblade.estate.wrapper.BillsWrapper;
import org.springblade.system.expand.feign.IOrgPositionClient;
import org.springblade.system.expand.util.QueryWrapperUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import com.baomidou.mybatisplus.core.metadata.IPage;

import org.springblade.core.boot.ctrl.BladeController;

import java.util.List;
import java.util.Map;

/**
 *  控制器
 *
 * @author BladeX
 * @since 2021-04-23
 */
//@EnableFeignClients
@RestController
@AllArgsConstructor
@RequestMapping("/bills")
@Api(value = "", tags = "接口")
public class BillsController extends BladeController {

	private final IBillsService billsService;
	private final IBillsItemService billsItemService;
	private final IFloorClient floorClient;

	private final IOrgPositionClient orgPositionClient;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入bills")
	public R<BillsVO> detail(Bills bills) {
		Bills detail = billsService.getOne(Condition.getQueryWrapper(bills));
		return R.data(BillsWrapper.build(billsItemService).entityVO(detail));
	}

	/**
	 * 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入bills")
	public R<IPage<BillsVO>> list(@RequestParam Map<String, Object> bills, Query query, BladeUser bladeUser) {
		LambdaQueryWrapper<Bills> wrapper = new QueryWrapperUtil<Bills>().getBasicQueryWrapperByMap(Bills::getOrgPosition, bills, new Bills(), bladeUser, orgPositionClient);
		IPage<Bills> pages = billsService.page(Condition.getPage(query), wrapper);
		return R.data(BillsWrapper.build(billsItemService).pageVO(pages));
	}


	/**
	 * 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入bills")
	public R<IPage<BillsVO>> page(BillsVO bills, Query query) {
		IPage<BillsVO> pages = billsService.selectBillsPage(Condition.getPage(query), bills);
		return R.data(pages);
	}

	/**
	 * 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入bills")
	public R save(@Valid @RequestBody Bills bills) {
		return R.status(billsService.save(bills));
	}

	/**
	 * 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入bills")
	public R update(@Valid @RequestBody Bills bills) {
		return R.status(billsService.updateById(bills));
	}

	/**
	 * 新增或修改
	 */
//	@PostMapping("/submit")
//	@ApiOperationSupport(order = 6)
//	@ApiOperation(value = "新增或修改", notes = "传入bills")
//	public R submit(@Valid @RequestBody Bills bills) {
//		return R.status(billsService.saveOrUpdate(bills));
//	}

	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入bills")
	public R submit(@Valid @RequestBody BillsDTO bills) {
		//设置orgPosition
		Floor floor = new Floor();
		floor.setId(bills.getFloorId());
		Floor floor1 = floorClient.detail(floor);
		bills.setOrgPosition(floor1.getOrgPosition()+"/"+bills.getRoomId());

		//统计费用
		double totalFee= 0;
		for (BillsItem billsItem: bills.getBillsItemList()) {
			totalFee += billsItem.getItemFee();
		}
		bills.setTotalFee(totalFee);
		Boolean bo = billsService.saveOrUpdate(bills);//先插入才能拿到Id？新增情况
		//新增
		for (BillsItem billsItem: bills.getBillsItemList()) {
			billsItem.setPid(bills.getId());
			billsItemService.saveOrUpdate(billsItem);
		}
		//获取当前所有的缴费项
		List<BillsItem> billsItemsAll = billsItemService.list(new QueryWrapper<BillsItem>().eq("pid",bills.getId()));
		//修改缴费项
//		for (BillsItem billsItem3 : bills.getBillsItemList()){
//			billsItemService.getBaseMapper().deleteById(billsItem3);
//			if (billsItemsAll.contains(billsItem3)){
//				billsItemService.updateDelZero(billsItem3.getId());
//			}
//		}
		//1、缴费项全部设置删除状态为1
		for (BillsItem billsItem2: billsItemsAll){
//			billsItemService.getBaseMapper().deleteById(billsItem2);
			billsItemService.updateDelOne(billsItem2.getPid());
		}
		//2、遍历传过来的缴费项对象列表，修改其删除状态为0
		for (BillsItem billsItem1 : bills.getBillsItemList()){
			billsItemService.updateDelZero(billsItem1.getId());
		}

		return R.status(bo);
	}


	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(billsService.deleteLogic(Func.toLongList(ids)));
	}


}
